/*
 * Copyright 2011-13 Fraunhofer ISE
 *
 * This file is part of OpenMUC.
 * For more information visit http://www.openmuc.org
 *
 * OpenMUC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * OpenMUC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with OpenMUC.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package org.openmuc.framework.config;

import java.util.Collection;

public interface DeviceConfig {

	public static final Boolean DISABLED_DEFAULT = false;
	public static final String NAME_DEFAULT = "";
	public static final String DESCRIPTION_DEFAULT = "";
	public static final String SETTINGS_DEFAULT = null;

	public String getDeviceAddress();

	public String getInterfaceAddress();

	public void setAddresses(String interfaceAddress, String deviceAddress) throws NamingCollisionException;

	public String getName();

	public void setName(String name);

	public String getDescription();

	public void setDescription(String description);

	public String getSettings();

	public void setSettings(String settings);

	public Integer getReadTimeout();

	public void setReadTimeout(Integer timeout);

	public Integer getConnectTimeout();

	public void setConnectTimeout(Integer timeout);

	public Integer getConnectRetryInterval();

	public void setConnectRetryInterval(Integer interval);

	public Boolean isDisabled();

	public void setDisabled(Boolean disabled);

	public ChannelConfig addChannel(String channelAddress) throws NamingCollisionException;

	public ChannelConfig addChannel(String channelAddress, String id) throws NamingCollisionException;

	public ChannelConfig getOrAddChannel(String channelAddress);

	public ChannelConfig getChannel(String channelAddress);

	public Collection<ChannelConfig> getChannels();

	public void delete();

}
